Welcome to Subscribe On Youtube

Formatted question description: https://leetcode.ca/all/2127.html

2127. Maximum Employees to Be Invited to a Meeting (Hard)

A company is organizing a meeting and has a list of n employees, waiting to be invited. They have arranged for a large circular table, capable of seating any number of employees.

The employees are numbered from 0 to n - 1. Each employee has a favorite person and they will attend the meeting only if they can sit next to their favorite person at the table. The favorite person of an employee is not themself.

Given a 0-indexed integer array favorite, where favorite[i] denotes the favorite person of the ith employee, return the maximum number of employees that can be invited to the meeting.

 

Example 1:

Input: favorite = [2,2,1,2]
Output: 3
Explanation:
The above figure shows how the company can invite employees 0, 1, and 2, and seat them at the round table.
All employees cannot be invited because employee 2 cannot sit beside employees 0, 1, and 3, simultaneously.
Note that the company can also invite employees 1, 2, and 3, and give them their desired seats.
The maximum number of employees that can be invited to the meeting is 3. 

Example 2:

Input: favorite = [1,2,0]
Output: 3
Explanation: 
Each employee is the favorite person of at least one other employee, and the only way the company can invite them is if they invite every employee.
The seating arrangement will be the same as that in the figure given in example 1:
- Employee 0 will sit between employees 2 and 1.
- Employee 1 will sit between employees 0 and 2.
- Employee 2 will sit between employees 1 and 0.
The maximum number of employees that can be invited to the meeting is 3.

Example 3:

Input: favorite = [3,0,1,4,1]
Output: 4
Explanation:
The above figure shows how the company will invite employees 0, 1, 3, and 4, and seat them at the round table.
Employee 2 cannot be invited because the two spots next to their favorite employee 0 are taken.
So the company leaves them out of the meeting.
The maximum number of employees that can be invited to the meeting is 4.

 

Constraints:

  • n == favorite.length
  • 2 <= n <= 105
  • 0 <= favorite[i] <= n - 1
  • favorite[i] != i

Similar Questions:

Solution 1. DFS

The answer is the maximum of:

  • the sum of all case 1 components
  • the maximum of case 2 components

  • // OJ: https://leetcode.com/problems/maximum-employees-to-be-invited-to-a-meeting/
    // Time: O(N)
    // Space: O(N)
    class Solution {
    public:
        int maximumInvitations(vector<int>& A) {
            int N = A.size();
            vector<int> m(N, -1); // m[i] is the depth of node i. -1 means unvisited
            vector<vector<int>> r(N); // The reverse graph
            for (int i = 0; i < N; ++i) r[A[i]].push_back(i);
            // handle case 1
            function<int(int)> dfs = [&](int u) {
                if (m[u] != -1) return m[u];
                int ans = 0;
                for (int v : r[u]) ans = max(ans, dfs(v));
                return m[u] = 1 + ans;
            };
            int ans = 0, free = 0;
            for (int i = 0; i < N; ++i) {
                if (m[i] != -1) continue; // skip visited nodes
                if (A[A[i]] == i) {
                    m[i] = m[A[i]] = 0;
                    int a = 0, b = 0; // find the length of the longest arms starting from `i` and `A[i]`
                    for (int v : r[i]) {
                        if (v == A[i]) continue;
                        a = max(a, dfs(v));
                    }
                    for (int v : r[A[i]]) {
                        if (v == i) continue;
                        b = max(b, dfs(v));
                    }
                    free += a + b + 2; // this free component is of length `a+b+2`
                }
            }
            // handle case 2
            function<tuple<int, int, bool>(int)> dfs2 = [&](int u)->tuple<int, int, bool> {
                if (m[u] != -1) return {u, m[u], false}; // We visited this node the second time, so this node must be the entry point to the cycle
                m[u] = 0;
                auto [entryPoint, depth, cycleVisited] = dfs2(A[u]);
                if (cycleVisited) { // After the cycle being traversed, any other node in the backtracking process are outside of the cycle and should be ignored (by keeping m[u] as 0).
                    return {entryPoint, depth, true};
                }
                m[u] = 1 + depth; // If we haven't met the entry point again, this is a node within the cycle, so we increment the depth.
                return {entryPoint, m[u], u == entryPoint}; // When we visit the entry point again, we know what we've done traversing the cycle.
            };
            for (int i = 0; i < N; ++i) {
                if(m[i] != -1) continue;
                auto [entryPoint, depth, cycleVisited] = dfs2(i);
                if (cycleVisited) ans = max(ans, depth);
            }
            return max(ans, free);
        }
    };
    
  • class Solution:
        def maximumInvitations(self, favorite: List[int]) -> int:
            def max_cycle(fa):
                n = len(fa)
                vis = [False] * n
                ans = 0
                for i in range(n):
                    if vis[i]:
                        continue
                    cycle = []
                    j = i
                    while not vis[j]:
                        cycle.append(j)
                        vis[j] = True
                        j = fa[j]
                    for k, v in enumerate(cycle):
                        if v == j:
                            ans = max(ans, len(cycle) - k)
                            break
                return ans
    
            def topological_sort(fa):
                n = len(fa)
                indeg = [0] * n
                dist = [1] * n
                for v in fa:
                    indeg[v] += 1
                q = deque([i for i, v in enumerate(indeg) if v == 0])
                while q:
                    i = q.popleft()
                    dist[fa[i]] = max(dist[fa[i]], dist[i] + 1)
                    indeg[fa[i]] -= 1
                    if indeg[fa[i]] == 0:
                        q.append(fa[i])
                return sum(dist[i] for i, v in enumerate(fa) if i == fa[fa[i]])
    
            return max(max_cycle(favorite), topological_sort(favorite))
    
    ############
    
    # 2127. Maximum Employees to Be Invited to a Meeting
    # https://leetcode.com/problems/maximum-employees-to-be-invited-to-a-meeting
    
    class Solution:
        def maximumInvitations(self, favorite: List[int]) -> int:
            n = len(favorite)
            graph = collections.defaultdict(list)
            
            for u, v in enumerate(favorite):
                graph[v].append(u)
            
            m = [-1] * n
            
            def dfs(u):
                if m[u] != -1: return m[u]
                
                res = 0
                
                for nei in graph[u]:
                    res = max(res, dfs(nei))
                
                m[u] = 1 + res
                
                return m[u]
            
            res1 = 0
            for u, v in enumerate(favorite):
                if m[u] != -1 or u != favorite[v]: continue
                
                m[u] = m[v] = 0
                
                a = 0
                for nei in graph[u]:
                    if nei == v: continue
                    a = max(a, dfs(nei))
                
                b = 0
                for nei in graph[v]:
                    if nei == u: continue
                    b = max(b, dfs(nei))
                
                res1 += a + b + 2
            
            res2 = 0
            
            def dfs2(u):
                t = 0
                seen = {}
                
                while u not in seen:
                    if m[u] != -1: return 0
                    seen[u] = t
                    u = favorite[u]
                    t += 1
                
                for v in seen.keys():
                    m[v] = 0
                
                return t - seen[u]
            
            for u in range(n):
                if m[u] != -1: continue
                
                res2 = max(res2, dfs2(u))
            
            return max(res1, res2)
                
                    
    
    
  • class Solution {
        public int maximumInvitations(int[] favorite) {
            return Math.max(maxCycle(favorite), topologicalSort(favorite));
        }
    
        private int maxCycle(int[] fa) {
            int n = fa.length;
            boolean[] vis = new boolean[n];
            int ans = 0;
            for (int i = 0; i < n; ++i) {
                if (vis[i]) {
                    continue;
                }
                List<Integer> cycle = new ArrayList<>();
                int j = i;
                while (!vis[j]) {
                    cycle.add(j);
                    vis[j] = true;
                    j = fa[j];
                }
                for (int k = 0; k < cycle.size(); ++k) {
                    if (cycle.get(k) == j) {
                        ans = Math.max(ans, cycle.size() - k);
                    }
                }
            }
            return ans;
        }
    
        private int topologicalSort(int[] fa) {
            int n = fa.length;
            int[] indeg = new int[n];
            int[] dist = new int[n];
            Arrays.fill(dist, 1);
            for (int v : fa) {
                indeg[v]++;
            }
            Deque<Integer> q = new ArrayDeque<>();
            for (int i = 0; i < n; ++i) {
                if (indeg[i] == 0) {
                    q.offer(i);
                }
            }
            int ans = 0;
            while (!q.isEmpty()) {
                int i = q.pollFirst();
                dist[fa[i]] = Math.max(dist[fa[i]], dist[i] + 1);
                if (--indeg[fa[i]] == 0) {
                    q.offer(fa[i]);
                }
            }
            for (int i = 0; i < n; ++i) {
                if (i == fa[fa[i]]) {
                    ans += dist[i];
                }
            }
            return ans;
        }
    }
    
  • func maximumInvitations(favorite []int) int {
    	a, b := maxCycle(favorite), topologicalSort(favorite)
    	return max(a, b)
    }
    
    func maxCycle(fa []int) int {
    	n := len(fa)
    	vis := make([]bool, n)
    	ans := 0
    	for i := range fa {
    		if vis[i] {
    			continue
    		}
    		j := i
    		cycle := []int{}
    		for !vis[j] {
    			cycle = append(cycle, j)
    			vis[j] = true
    			j = fa[j]
    		}
    		for k, v := range cycle {
    			if v == j {
    				ans = max(ans, len(cycle)-k)
    				break
    			}
    		}
    	}
    	return ans
    }
    
    func topologicalSort(fa []int) int {
    	n := len(fa)
    	indeg := make([]int, n)
    	dist := make([]int, n)
    	for i := range fa {
    		dist[i] = 1
    	}
    	for _, v := range fa {
    		indeg[v]++
    	}
    	q := []int{}
    	for i, v := range indeg {
    		if v == 0 {
    			q = append(q, i)
    		}
    	}
    	for len(q) > 0 {
    		i := q[0]
    		q = q[1:]
    		dist[fa[i]] = max(dist[fa[i]], dist[i]+1)
    		indeg[fa[i]]--
    		if indeg[fa[i]] == 0 {
    			q = append(q, fa[i])
    		}
    	}
    	ans := 0
    	for i := range fa {
    		if i == fa[fa[i]] {
    			ans += dist[i]
    		}
    	}
    	return ans
    }
    
    func max(a, b int) int {
    	if a > b {
    		return a
    	}
    	return b
    }
    
  • function maximumInvitations(favorite: number[]): number {
        return Math.max(maxCycle(favorite), topologicalSort(favorite));
    }
    
    function maxCycle(fa: number[]): number {
        const n = fa.length;
        const vis: boolean[] = Array(n).fill(false);
        let ans = 0;
        for (let i = 0; i < n; ++i) {
            if (vis[i]) {
                continue;
            }
            const cycle: number[] = [];
            let j = i;
            for (; !vis[j]; j = fa[j]) {
                cycle.push(j);
                vis[j] = true;
            }
            for (let k = 0; k < cycle.length; ++k) {
                if (cycle[k] === j) {
                    ans = Math.max(ans, cycle.length - k);
                }
            }
        }
        return ans;
    }
    
    function topologicalSort(fa: number[]): number {
        const n = fa.length;
        const indeg: number[] = Array(n).fill(0);
        const dist: number[] = Array(n).fill(1);
        for (const v of fa) {
            ++indeg[v];
        }
        const q: number[] = [];
        for (let i = 0; i < n; ++i) {
            if (indeg[i] === 0) {
                q.push(i);
            }
        }
        let ans = 0;
        while (q.length) {
            const i = q.pop()!;
            dist[fa[i]] = Math.max(dist[fa[i]], dist[i] + 1);
            if (--indeg[fa[i]] === 0) {
                q.push(fa[i]);
            }
        }
        for (let i = 0; i < n; ++i) {
            if (i === fa[fa[i]]) {
                ans += dist[i];
            }
        }
        return ans;
    }
    
    

Discuss

https://leetcode.com/problems/maximum-employees-to-be-invited-to-a-meeting/discuss/1660944/C%2B%2B-DFS-with-illustration

All Problems

All Solutions